import com.ibm.aglet.*;
import com.ibm.aglet.event.*;
import java.net.*;
import java.io.*;
import java.net.URL;
import java.security.Security;
import java.security.*;
import java.math.BigInteger;
import java.math.*;
import java.util.*;
/**
 * This aglet does the job of Evaluator One. It finds the maximum of
 * enc(encWeight w(1,2)+ f(2)) and enc(w(1,3)) which is f(1).Then it adds the enc(w(0,1))
 * to f(1) and sends it back to the DynaProEncryptionAgletApp.
 */

public class EvaluatorOne extends Aglet {
	boolean retracted = false;
	BigInteger encryptedResult ;
	static BigInteger [][] encWeight13Array = new BigInteger [6][2];
	static BigInteger [][] shiftedArray = new BigInteger [6][2];
	static BigInteger [][] randomizedArray = new BigInteger [6][2];
	static BigInteger [][] weightPlusConstantArray = new BigInteger [6][2];
    static BigInteger [][] encWeight01Array = new BigInteger [6][2];
	static BigInteger [][] optValf2plusEncWt12Array = new BigInteger [6][2];
	static BigInteger [][] MaxWeightArray = new BigInteger [6][2];
	/** p (modulo) is a very large prime number **/
	static BigInteger p = new BigInteger("23");
	/** n is the length of the array which is large enough to represent the
	* length of the longest path. Not a variable.
 	*/
	static int n = 6;
	/** z is the common public element. Not a variable **/
	static String z = "5";
	/** r is the random number chosen for encryption. Variable.**/
	String r = "0";

/** handles the transfer of the result to the aglet
 * that dispatched this aglet
 */
	public boolean handleMessage(Message msg){
		if(msg.sameKind("result")){
			System.out.println("\n");
			System.out.println("Returning the the maximum weight array (final result)....");
			System.out.println("\n");
			msg.sendReply(weightPlusConstantArray);
			return true;
		} else
			return false;
		}
/**
 * onCreation is called when the aglet is created and the arguments(args) are
 * paased from the creator aglet.
 */
	public void onCreation(final Object  args) {
		//System.out.println("onCreation is called");

	addMobilityListener(
			new MobilityAdapter() {
				/**
				 * args values are assigned to Local variables
				 */
				 BigInteger [][] encWeight13Array = (BigInteger [][])((Object[])args)[0];
				 BigInteger [][] optValf2plusEncWt12Array = (BigInteger [][])((Object[])args)[1];
				 BigInteger [][] encWeight01Array = (BigInteger[][])((Object[])args)[2];




			    /**
			     * This function is called both the times when the aglet arrives
			     * at the destination(retracted = false) as well as when it is retracted
			     * (retracted = true)back.
			     */
				public void onArrival(MobilityEvent e) {
					try {
						if(retracted) {
							//System.out.println("The returned encryptedResult is "+encryptedResult);
				 		}else {
						   try{
							   System.out.println("\n");
							   System.out.println("Evaluator 1 arriving at the destination....");
							   System.out.println("\n");
							   String tableString = "";
							   for(int i = 0; i < n; i++){
							   		for(int j = 0; j < encWeight01Array[i].length; j++){
							   			tableString += encWeight01Array[i][j]+ "  ";
							   		}
							   		tableString += "\n";
							   }
							   System.out.println("Encrypted weight of the link (0,1) received from the weight publisher");
							   System.out.println(tableString);
							   tableString = "";
							   for(int i = 0; i < n; i++){
								   for(int j = 0; j < encWeight13Array[i].length; j++){
			   							tableString += encWeight13Array[i][j]+ "  ";
			   				       }
							   	   tableString += "\n";
					           }
							   System.out.println("Encrypted weight of the link (1,3) received from the weight publisher");
							   System.out.println(tableString);

					     	   tableString = "";
							   for(int i = 0; i < n; i++){
							    	for(int j = 0; j < optValf2plusEncWt12Array[i].length; j++){
							   			tableString += optValf2plusEncWt12Array[i][j]+ "  ";
							  		}
									tableString += "\n";
							   }
							   System.out.println("weight of the link (1,2) + weight of the link (2,3)  received from the weight publisher");
							   System.out.println(tableString);

							   /**/
							   /** Finding the maximum of encWeight13Array and
							    *	optValf2plusEncWt12Array
							    */
							    int maxWeight = 0;
							    maxWeight = findMaxWeight( n);

							    /** Variables needed to fill up the randomized Array **/
								 int w = 0;
								 r = "9";
							    int f;

								/**Fills up randomized array in preparation for adding f(1) with
								 * thirdEncWeightArray
								 */
								 f =  maxWeight;
								 //System.out.println("f = "+f);

							     jayElGamel(w,n,z,r,f);

							     /** Function that fills the shifted array in preparation
								  * for adding f(1) with thirdEncWeightArray
								  */
								  fillShiftedArray(f, n);

								 /** Function that fills the weightPlusConstant array **/
							      fillweightPlusConstantArray(f,n);

							      //findMaxWeight(n);




						/**/
						   }catch (Exception m){
						   }
	    	       	   }
					}catch (Exception me) {
						dispose();
					}

				}//End of onArrival

				public void onReverting(MobilityEvent e) {

					retracted = true;

				}
				/***/

				private  void jayElGamel( int ww,int nn, String zz,String rr, int ff){
					final BigInteger ONE = new BigInteger("1");

					/** g is the base number **/
					BigInteger g = new BigInteger("5");
					/** x is the secret key. Not a variable. **/
					BigInteger x = new BigInteger("2");

					/** msg is the number to be encrypted **/
					BigInteger msg;
					/** r is the random number chosen for encryption**/
					BigInteger r = new BigInteger(rr);;
					for(int i = 0; i < nn; i++){
						if(ww > 0 && ff == 0 ){
							msg = new BigInteger(zz);
						}else if( ww ==0 && ff > 0 ){
							msg = new BigInteger(zz);
						}else {
							msg = new BigInteger("1");
						}
						/** y is the public key **/
						BigInteger y = new BigInteger("0");
						/** y1 is the first part of the encrypted value **/
						BigInteger y1 = new BigInteger("0");
						/** y2 is the second part of the encrypted value **/
						BigInteger y2 = new BigInteger("0");
						/** temporary variables: temp,t2 and t1 **/
						BigInteger temp = new BigInteger("0");
						BigInteger t2 = new BigInteger("0");
						int t1 = 0;

						y = g.modPow(x,p);

						//System.out.println("Y is "+y);
						y1 = g.modPow(r,p);
						if(rr == "1"){
							encWeight13Array[i][0] = y1;
						}else if(rr =="5"){
							encWeight01Array[i][0] = y1;
						}else {
							randomizedArray[i][0] = y1;
			 			}
						//System.out.println("y1 is "+y1);
						t1 = r.intValue();
						y2 = (msg.multiply(y.pow(t1))).mod(p);
						//System.out.println("msg is "+msg);

						if(rr == "1"){
							encWeight13Array[i][1] = y2;
						}else if(rr =="5"){
							encWeight01Array[i][1] = y2;
						}else {
							randomizedArray[i][1] = y2;
						}

						//System.out.println("y2 is "+y2);
						t1 = x.intValue();
						y1 = y1.pow(t1);
						temp = y1.modInverse(p);
						msg = y2.multiply(temp);
						//System.out.println("Message is "+msg);
						if(rr == "1" || rr == "5"){
					   		ww--;
						} else if(rr == "9"){
							ff--;
						}else{
						}
						r = r.add(ONE);
						//System.out.println("r is "+r);
					}//End of for loop


				}//End of jayElGamel

				private  void fillShiftedArray(int f, int nn){
					int m = 0;
					for(int i = 0; i < f; i++){
						for(int j = 0; j < shiftedArray[i].length; j++){
							shiftedArray[i][j] = randomizedArray[i][j];
						}
					}

					for(int i = f; i < nn; i++){
						//System.out.println("entering");
						//System.out.println("m is"+m);
						for(int j = 0; j < shiftedArray[i].length; j++){
							shiftedArray[i][j] = encWeight01Array[m][j];
						}
						m++;
				    }
					String tableString = "";
					for(int i = 0; i < nn; i++){
						for(int j = 0; j < shiftedArray[i].length; j++){
							tableString += shiftedArray[i][j]+ "  ";
						}
						tableString += "\n";
					}
					System.out.println("Encrypted Weight of the link (0, 1) + optimal value of the node 1");
					System.out.println(tableString);

				}//End of fillShiftedArray

				private  void fillweightPlusConstantArray(int f, int nn){

					for(int i = 0; i < f; i++){
						for(int j = 0; j < weightPlusConstantArray[i].length; j++){
							weightPlusConstantArray[i][j] = randomizedArray[i][j];
						}

					}

					for(int i = f; i < nn; i++){
						for(int j = 0; j < weightPlusConstantArray[i].length; j++){
							weightPlusConstantArray[i][j] = (shiftedArray[i][j].multiply(randomizedArray[i][j])).mod(p);
						}

					}
					String tableString = "";
					for(int i = 0; i < nn; i++){
						for(int j = 0; j < weightPlusConstantArray[i].length; j++){
							tableString += weightPlusConstantArray[i][j]+ "  ";
						}
						tableString += "\n";
					}
					System.out.println("Encrypted Weight of the link (0,1) + optimal value of the node 1 after randomizing");
					System.out.println(tableString);

				}//End of fillweightPlusConstantArray



				private  int findMaxWeight(int nn){

							int maxWeight = 0;
							BigInteger msg;
							BigInteger y1;
							BigInteger y2;
							BigInteger temp = new BigInteger("0");
							BigInteger x = new BigInteger("2");
							BigInteger p = new BigInteger("23");
							BigInteger FIVE = new BigInteger("5");
							int t1 = 0;

							for(int i = 0; i < nn; i++){
								for(int j = 0; j < MaxWeightArray[i].length; j++){
									MaxWeightArray[i][j] = (optValf2plusEncWt12Array[i][j].multiply(encWeight13Array[i][j])).mod(p);
								}

							}

							String tableString = "";
								for(int i = 0; i < nn; i++){
									for(int j = 0; j < MaxWeightArray[i].length; j++){
										tableString += MaxWeightArray[i][j]+ "  ";
									}
									tableString += "\n";
								}
							System.out.println("\n");
							System.out.println("Encrypted  Optimal value of the node 1 calculated by this Evaluator");
							System.out.println(tableString);

							t1 = x.intValue();
							//System.out.println("Before Entering the last loop");
							for(int i = nn-1; i >= 0; i--){
								//System.out.println("Entering the last loop");
								y1 = MaxWeightArray[i][0];
								y2 = MaxWeightArray[i][1];
								y1 = y1.pow(t1);
								temp = y1.modInverse(p);
								msg = (y2.multiply(temp)).mod(p);

								//System.out.println("Message is "+msg);
								if(msg.equals(FIVE)){
									 maxWeight = i+1;
									 System.out.println("\n");
									 System.out.println("Optimal value of node 1 = "+maxWeight);
									//System.out.println("i = "+i);
									break;
								}

							}
							return maxWeight;


						}//End of findMaxweight

				/***/


			}//End of MobilityAdapter
		);//End of addMobilityListener
	}//End of onCreation
}//End of class
