import com.ibm.aglet.*;
import com.ibm.aglet.event.*;
import java.net.*;
import java.io.*;
import java.net.URL;
import java.security.Security;
import java.security.*;
import java.math.BigInteger;
import java.math.*;
import java.util.*;
/**
 * This aglet does the multiplication of the two
 * encrypted integers
 */


public class MMHEncryptDecrypt extends Aglet {
	boolean retracted = false;
	BigInteger encryptedResult ;

/** handles the transfer of the result to the aglet
 * that dispatched this aglet
 */
	public boolean handleMessage(Message msg){
		if(msg.sameKind("result")){
			msg.sendReply(encryptedResult);
			return true;

		} else
			return false;
		}

/**
 * onCreation is called when the aglet is created and the arguments(args) are
 * paased from the creator aglet.
 */
	public void onCreation(final Object  args) {
		System.out.println("onCreation is called");

	addMobilityListener(
			new MobilityAdapter() {
				/**
				 * args values are assigned to Local variables
				 */
				 BigInteger encryptedX1 = (BigInteger)((Object[])args)[0];
				 BigInteger encryptedX2 = (BigInteger)((Object[])args)[1];
				 BigInteger n =  (BigInteger)((Object[])args)[2];

			    /**
			     * This function is called both the times when the aglet arrives
			     * at the destination(retracted = false) as well as when it is retracted
			     * (retracted = true)back.
			     */
				public void onArrival(MobilityEvent e) {
					try {
						if(retracted) {
							//System.out.println("The product of encrypted X1 and X2 returned from the destination by message passing is " +encryptedResult);
				 		}else {
						   try{
							   System.out.println("Proxy aglet arriving here at the destination");
							   System.out.println("\n");
							   System.out.println("encrypted value of number X1="+encryptedX1);
							   System.out.println("encrypted value of number X2="+encryptedX2);
							   System.out.println("modulus n = "+n);
							    System.out.println("\n");
							   encryptedResult = (encryptedX1.multiply(encryptedX2)).mod(n);

							   System.out.println("encryptedResult of (X1 x X2) calculated by proxy which is (encryptedX1.multiply(encryptedX2)).mod(n) = " +encryptedResult);
						 	  System.out.println("\n");
						 	  System.out.println("Proxy returning the result in response to message from the original aglet at the origin....");
						 	   System.out.println("\n");

						 }catch (Exception m){
						   }
	    	       	   }
					}catch (Exception me) {
						dispose();
					}

				}

				public void onReverting(MobilityEvent e) {

					retracted = true;

				}

			}
		);
	}
}
